#include <iostream>
#include<vector>

using namespace std;
static void update(int n,int k,vector<vector<int>>&a,vector<bool>&posecen,vector<int>&los,vector<pair<int,int>>&nizv)
{
    posecen[k]=true;
    if(los[k]==1)return;
    for(int i=0;i<a[k].size();i++)
    {
        if(!posecen[a[k][i]])
        {
            update(n,a[k][i],a,posecen,los,nizv);
            nizv.push_back(make_pair(k,a[k][i]));
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin>>tt;
    while(tt--)
    {
        int n,m,s;
        cin>>n>>m>>s;
        vector<int>los(n+1,0);
        for(int i=0;i<s;i++){
            int d;
            cin>>d;
            los[d]=1;
        }
        vector<vector<int>>a(n+1);
        for(int i=0;i<m;i++)
        {
            int br1,br2;
            cin>>br1>>br2;
            a[br1].push_back(br2);
            a[br2].push_back(br1);
        }
        vector<bool>posecen(n+1,false);
        vector<pair<int,int>>nizv;
        int prvinelos=1;
        for(int i=1;i<=n;i++)
        {
            if(los[i]!=1){prvinelos=i;break;}
        }
        update(n,prvinelos,a,posecen,los,nizv);
        bool svipos=true;
        for(int i=1;i<=n;i++)
        {
            if(!posecen[i])
                svipos=false;
        }
        if(!svipos)
            cout<<-1<<endl;
        else
        {
            cout<<nizv.size()<<endl;
            for(int i=0;i<nizv.size();i++)
                cout<<nizv[i].first<<" "<<nizv[i].second<<endl;
        }
    }
}